| OpenCV 3.4.1 Open Source Computer Vision

Public Member Functions | Static Public Member Functions | List of all members
cv::cuda::DescriptorMatcher Class Referenceabstract
Core functionality » OpenGL interoperability » CUDA-accelerated Computer Vision » Feature Detection and Description

Abstract base class for matching keypoint descriptors. More...

`#include "cudafeatures2d.hpp"`

Inheritance diagram for cv::cuda::DescriptorMatcher:

## Public Member Functions
virtual void | add (const std::vector< GpuMat > &descriptors)=0
| Adds descriptors to train a descriptor collection. More...
virtual void | clear ()=0
| Clears the train descriptor collection. More...
virtual bool | empty () const =0
| Returns true if there are no train descriptors in the collection. More...
virtual const std::vector< GpuMat > & | getTrainDescriptors () const =0
| Returns a constant link to the train descriptor collection. More...
virtual bool | isMaskSupported () const =0
| Returns true if the descriptor matcher supports masking permissible matches. More...
virtual void | knnMatch (InputArray queryDescriptors, InputArray trainDescriptors, std::vector< std::vector< DMatch > > &matches, int k, InputArray mask=noArray(), bool compactResult=false)=0
| Finds the k best matches for each descriptor from a query set (blocking version). More...
virtual void | knnMatch (InputArray queryDescriptors, std::vector< std::vector< DMatch > > &matches, int k, const std::vector< GpuMat > &masks=std::vector< GpuMat >(), bool compactResult=false)=0
virtual void | knnMatchAsync (InputArray queryDescriptors, InputArray trainDescriptors, OutputArray matches, int k, InputArray mask=noArray(), Stream &stream=Stream::Null())=0
| Finds the k best matches for each descriptor from a query set (asynchronous version). More...
virtual void | knnMatchAsync (InputArray queryDescriptors, OutputArray matches, int k, const std::vector< GpuMat > &masks=std::vector< GpuMat >(), Stream &stream=Stream::Null())=0
virtual void | knnMatchConvert (InputArray gpu_matches, std::vector< std::vector< DMatch > > &matches, bool compactResult=false)=0
| Converts matches array from internal representation to standard matches vector. More...
virtual void | match (InputArray queryDescriptors, InputArray trainDescriptors, std::vector< DMatch > &matches, InputArray mask=noArray())=0
| Finds the best match for each descriptor from a query set (blocking version). More...
virtual void | match (InputArray queryDescriptors, std::vector< DMatch > &matches, const std::vector< GpuMat > &masks=std::vector< GpuMat >())=0
virtual void | matchAsync (InputArray queryDescriptors, InputArray trainDescriptors, OutputArray matches, InputArray mask=noArray(), Stream &stream=Stream::Null())=0
| Finds the best match for each descriptor from a query set (asynchronous version). More...
virtual void | matchAsync (InputArray queryDescriptors, OutputArray matches, const std::vector< GpuMat > &masks=std::vector< GpuMat >(), Stream &stream=Stream::Null())=0
virtual void | matchConvert (InputArray gpu_matches, std::vector< DMatch > &matches)=0
| Converts matches array from internal representation to standard matches vector. More...
virtual void | radiusMatch (InputArray queryDescriptors, InputArray trainDescriptors, std::vector< std::vector< DMatch > > &matches, float maxDistance, InputArray mask=noArray(), bool compactResult=false)=0
| For each query descriptor, finds the training descriptors not farther than the specified distance (blocking version). More...
virtual void | radiusMatch (InputArray queryDescriptors, std::vector< std::vector< DMatch > > &matches, float maxDistance, const std::vector< GpuMat > &masks=std::vector< GpuMat >(), bool compactResult=false)=0
virtual void | radiusMatchAsync (InputArray queryDescriptors, InputArray trainDescriptors, OutputArray matches, float maxDistance, InputArray mask=noArray(), Stream &stream=Stream::Null())=0
| For each query descriptor, finds the training descriptors not farther than the specified distance (asynchronous version). More...
virtual void | radiusMatchAsync (InputArray queryDescriptors, OutputArray matches, float maxDistance, const std::vector< GpuMat > &masks=std::vector< GpuMat >(), Stream &stream=Stream::Null())=0
virtual void | radiusMatchConvert (InputArray gpu_matches, std::vector< std::vector< DMatch > > &matches, bool compactResult=false)=0
| Converts matches array from internal representation to standard matches vector. More...
virtual void | train ()=0
| Trains a descriptor matcher. More...
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage. More...
virtual void | save (const String &filename) const
virtual void | write (FileStorage &fs) const
| Stores algorithm parameters in a file storage. More...
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
| simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...

## Static Public Member Functions
static Ptr< DescriptorMatcher > | createBFMatcher (int normType=cv::NORM_L2)
| Brute-force descriptor matcher. More...
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file. More...
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String. More...
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node. More...

## Additional Inherited Members
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Abstract base class for matching keypoint descriptors.

It has two groups of match methods: for matching descriptors of an image with another image or with an image set.

## Member Function Documentation

## § add()

virtual void cv::cuda::DescriptorMatcher::add | ( | const std::vector< GpuMat > & | descriptors | ) |
| pure virtual

Adds descriptors to train a descriptor collection.

If the collection is not empty, the new descriptors are added to existing train descriptors.

Parameters

  descriptors | Descriptors to add. Each descriptors[i] is a set of descriptors from the same train image.

## § clear()

virtual void cv::cuda::DescriptorMatcher::clear | ( |  | ) |
| pure virtual

Clears the train descriptor collection.

Reimplemented from cv::Algorithm.

## § createBFMatcher()

static Ptr<DescriptorMatcher> cv::cuda::DescriptorMatcher::createBFMatcher | ( | int | normType = `cv::NORM_L2` | ) |
| static

Brute-force descriptor matcher.

For each descriptor in the first set, this matcher finds the closest descriptor in the second set by trying each one. This descriptor matcher supports masking permissible matches of descriptor sets.

Parameters

  normType | One of NORM_L1, NORM_L2, NORM_HAMMING. L1 and L2 norms are preferable choices for SIFT and SURF descriptors, NORM_HAMMING should be used with ORB, BRISK and BRIEF).

## § empty()

virtual bool cv::cuda::DescriptorMatcher::empty | ( |  | ) | const
| pure virtual

Returns true if there are no train descriptors in the collection.

Reimplemented from cv::Algorithm.

## § getTrainDescriptors()

virtual const std::vector<GpuMat>& cv::cuda::DescriptorMatcher::getTrainDescriptors | ( |  | ) | const
| pure virtual

Returns a constant link to the train descriptor collection.

## § isMaskSupported()

virtual bool cv::cuda::DescriptorMatcher::isMaskSupported | ( |  | ) | const
| pure virtual

Returns true if the descriptor matcher supports masking permissible matches.

## § knnMatch() [1/2]

virtual void cv::cuda::DescriptorMatcher::knnMatch | ( | InputArray | queryDescriptors,
|  | InputArray | trainDescriptors,
|  | std::vector< std::vector< DMatch > > & | matches,
|  | int | k,
|  | InputArray | mask = `noArray()`,
|  | bool | compactResult = `false`
| ) |  |
| pure virtual

Finds the k best matches for each descriptor from a query set (blocking version).

Parameters

  queryDescriptors | Query set of descriptors.
  trainDescriptors | Train set of descriptors. This set is not added to the train descriptors collection stored in the class object.
  matches | Matches. Each matches[i] is k or less matches for the same query descriptor.
  k | Count of best matches found per each query descriptor or less if a query descriptor has less than k possible matches in total.
  mask | Mask specifying permissible matches between an input query and train matrices of descriptors.
  compactResult | Parameter used when the mask (or masks) is not empty. If compactResult is false, the matches vector has the same size as queryDescriptors rows. If compactResult is true, the matches vector does not contain matches for fully masked-out query descriptors.

These extended variants of DescriptorMatcher::match methods find several best matches for each query descriptor. The matches are returned in the distance increasing order. See DescriptorMatcher::match for the details about query and train descriptors.

## § knnMatch() [2/2]

virtual void cv::cuda::DescriptorMatcher::knnMatch | ( | InputArray | queryDescriptors,
|  | std::vector< std::vector< DMatch > > & | matches,
|  | int | k,
|  | const std::vector< GpuMat > & | masks = `std::vector< GpuMat >()`,
|  | bool | compactResult = `false`
| ) |  |
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## § knnMatchAsync() [1/2]

virtual void cv::cuda::DescriptorMatcher::knnMatchAsync | ( | InputArray | queryDescriptors,
|  | InputArray | trainDescriptors,
|  | OutputArray | matches,
|  | int | k,
|  | InputArray | mask = `noArray()`,
|  | Stream & | stream = `Stream::Null()`
| ) |  |
| pure virtual

Finds the k best matches for each descriptor from a query set (asynchronous version).

Parameters

  queryDescriptors | Query set of descriptors.
  trainDescriptors | Train set of descriptors. This set is not added to the train descriptors collection stored in the class object.
  matches | Matches array stored in GPU memory. Internal representation is not defined. Use DescriptorMatcher::knnMatchConvert method to retrieve results in standard representation.
  k | Count of best matches found per each query descriptor or less if a query descriptor has less than k possible matches in total.
  mask | Mask specifying permissible matches between an input query and train matrices of descriptors.
  stream | CUDA stream.

These extended variants of DescriptorMatcher::matchAsync methods find several best matches for each query descriptor. The matches are returned in the distance increasing order. See DescriptorMatcher::matchAsync for the details about query and train descriptors.

## § knnMatchAsync() [2/2]

virtual void cv::cuda::DescriptorMatcher::knnMatchAsync | ( | InputArray | queryDescriptors,
|  | OutputArray | matches,
|  | int | k,
|  | const std::vector< GpuMat > & | masks = `std::vector< GpuMat >()`,
|  | Stream & | stream = `Stream::Null()`
| ) |  |
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## § knnMatchConvert()

virtual void cv::cuda::DescriptorMatcher::knnMatchConvert | ( | InputArray | gpu_matches,
|  | std::vector< std::vector< DMatch > > & | matches,
|  | bool | compactResult = `false`
| ) |  |
| pure virtual

Converts matches array from internal representation to standard matches vector.

The method is supposed to be used with DescriptorMatcher::knnMatchAsync to get final result. Call this method only after DescriptorMatcher::knnMatchAsync is completed (ie. after synchronization).

Parameters

  gpu_matches | Matches, returned from DescriptorMatcher::knnMatchAsync.
  matches | Vector of DMatch objects.
  compactResult | Parameter used when the mask (or masks) is not empty. If compactResult is false, the matches vector has the same size as queryDescriptors rows. If compactResult is true, the matches vector does not contain matches for fully masked-out query descriptors.

## § match() [1/2]

virtual void cv::cuda::DescriptorMatcher::match | ( | InputArray | queryDescriptors,
|  | InputArray | trainDescriptors,
|  | std::vector< DMatch > & | matches,
|  | InputArray | mask = `noArray()`
| ) |  |
| pure virtual

Finds the best match for each descriptor from a query set (blocking version).

Parameters

  queryDescriptors | Query set of descriptors.
  trainDescriptors | Train set of descriptors. This set is not added to the train descriptors collection stored in the class object.
  matches | Matches. If a query descriptor is masked out in mask , no match is added for this descriptor. So, matches size may be smaller than the query descriptors count.
  mask | Mask specifying permissible matches between an input query and train matrices of descriptors.

In the first variant of this method, the train descriptors are passed as an input argument. In the second variant of the method, train descriptors collection that was set by DescriptorMatcher::add is used. Optional mask (or masks) can be passed to specify which query and training descriptors can be matched. Namely, queryDescriptors[i] can be matched with trainDescriptors[j] only if mask.at<uchar>(i,j) is non-zero.

## § match() [2/2]

virtual void cv::cuda::DescriptorMatcher::match | ( | InputArray | queryDescriptors,
|  | std::vector< DMatch > & | matches,
|  | const std::vector< GpuMat > & | masks = `std::vector< GpuMat >()`
| ) |  |
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## § matchAsync() [1/2]

virtual void cv::cuda::DescriptorMatcher::matchAsync | ( | InputArray | queryDescriptors,
|  | InputArray | trainDescriptors,
|  | OutputArray | matches,
|  | InputArray | mask = `noArray()`,
|  | Stream & | stream = `Stream::Null()`
| ) |  |
| pure virtual

Finds the best match for each descriptor from a query set (asynchronous version).

Parameters

  queryDescriptors | Query set of descriptors.
  trainDescriptors | Train set of descriptors. This set is not added to the train descriptors collection stored in the class object.
  matches | Matches array stored in GPU memory. Internal representation is not defined. Use DescriptorMatcher::matchConvert method to retrieve results in standard representation.
  mask | Mask specifying permissible matches between an input query and train matrices of descriptors.
  stream | CUDA stream.

In the first variant of this method, the train descriptors are passed as an input argument. In the second variant of the method, train descriptors collection that was set by DescriptorMatcher::add is used. Optional mask (or masks) can be passed to specify which query and training descriptors can be matched. Namely, queryDescriptors[i] can be matched with trainDescriptors[j] only if mask.at<uchar>(i,j) is non-zero.

## § matchAsync() [2/2]

virtual void cv::cuda::DescriptorMatcher::matchAsync | ( | InputArray | queryDescriptors,
|  | OutputArray | matches,
|  | const std::vector< GpuMat > & | masks = `std::vector< GpuMat >()`,
|  | Stream & | stream = `Stream::Null()`
| ) |  |
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## § matchConvert()

virtual void cv::cuda::DescriptorMatcher::matchConvert | ( | InputArray | gpu_matches,
|  | std::vector< DMatch > & | matches
| ) |  |
| pure virtual

Converts matches array from internal representation to standard matches vector.

The method is supposed to be used with DescriptorMatcher::matchAsync to get final result. Call this method only after DescriptorMatcher::matchAsync is completed (ie. after synchronization).

Parameters

  gpu_matches | Matches, returned from DescriptorMatcher::matchAsync.
  matches | Vector of DMatch objects.

## § radiusMatch() [1/2]

virtual void cv::cuda::DescriptorMatcher::radiusMatch | ( | InputArray | queryDescriptors,
|  | InputArray | trainDescriptors,
|  | std::vector< std::vector< DMatch > > & | matches,
|  | float | maxDistance,
|  | InputArray | mask = `noArray()`,
|  | bool | compactResult = `false`
| ) |  |
| pure virtual

For each query descriptor, finds the training descriptors not farther than the specified distance (blocking version).

Parameters

  queryDescriptors | Query set of descriptors.
  trainDescriptors | Train set of descriptors. This set is not added to the train descriptors collection stored in the class object.
  matches | Found matches.
  maxDistance | Threshold for the distance between matched descriptors. Distance means here metric distance (e.g. Hamming distance), not the distance between coordinates (which is measured in Pixels)!
  mask | Mask specifying permissible matches between an input query and train matrices of descriptors.
  compactResult | Parameter used when the mask (or masks) is not empty. If compactResult is false, the matches vector has the same size as queryDescriptors rows. If compactResult is true, the matches vector does not contain matches for fully masked-out query descriptors.

For each query descriptor, the methods find such training descriptors that the distance between the query descriptor and the training descriptor is equal or smaller than maxDistance. Found matches are returned in the distance increasing order.

## § radiusMatch() [2/2]

virtual void cv::cuda::DescriptorMatcher::radiusMatch | ( | InputArray | queryDescriptors,
|  | std::vector< std::vector< DMatch > > & | matches,
|  | float | maxDistance,
|  | const std::vector< GpuMat > & | masks = `std::vector< GpuMat >()`,
|  | bool | compactResult = `false`
| ) |  |
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## § radiusMatchAsync() [1/2]

virtual void cv::cuda::DescriptorMatcher::radiusMatchAsync | ( | InputArray | queryDescriptors,
|  | InputArray | trainDescriptors,
|  | OutputArray | matches,
|  | float | maxDistance,
|  | InputArray | mask = `noArray()`,
|  | Stream & | stream = `Stream::Null()`
| ) |  |
| pure virtual

For each query descriptor, finds the training descriptors not farther than the specified distance (asynchronous version).

Parameters

  queryDescriptors | Query set of descriptors.
  trainDescriptors | Train set of descriptors. This set is not added to the train descriptors collection stored in the class object.
  matches | Matches array stored in GPU memory. Internal representation is not defined. Use DescriptorMatcher::radiusMatchConvert method to retrieve results in standard representation.
  maxDistance | Threshold for the distance between matched descriptors. Distance means here metric distance (e.g. Hamming distance), not the distance between coordinates (which is measured in Pixels)!
  mask | Mask specifying permissible matches between an input query and train matrices of descriptors.
  stream | CUDA stream.

For each query descriptor, the methods find such training descriptors that the distance between the query descriptor and the training descriptor is equal or smaller than maxDistance. Found matches are returned in the distance increasing order.

## § radiusMatchAsync() [2/2]

virtual void cv::cuda::DescriptorMatcher::radiusMatchAsync | ( | InputArray | queryDescriptors,
|  | OutputArray | matches,
|  | float | maxDistance,
|  | const std::vector< GpuMat > & | masks = `std::vector< GpuMat >()`,
|  | Stream & | stream = `Stream::Null()`
| ) |  |
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## § radiusMatchConvert()

virtual void cv::cuda::DescriptorMatcher::radiusMatchConvert | ( | InputArray | gpu_matches,
|  | std::vector< std::vector< DMatch > > & | matches,
|  | bool | compactResult = `false`
| ) |  |
| pure virtual

Converts matches array from internal representation to standard matches vector.

The method is supposed to be used with DescriptorMatcher::radiusMatchAsync to get final result. Call this method only after DescriptorMatcher::radiusMatchAsync is completed (ie. after synchronization).

Parameters

  gpu_matches | Matches, returned from DescriptorMatcher::radiusMatchAsync.
  matches | Vector of DMatch objects.
  compactResult | Parameter used when the mask (or masks) is not empty. If compactResult is false, the matches vector has the same size as queryDescriptors rows. If compactResult is true, the matches vector does not contain matches for fully masked-out query descriptors.

## § train()

virtual void cv::cuda::DescriptorMatcher::train | ( |  | ) |
| pure virtual

Trains a descriptor matcher.

Trains a descriptor matcher (for example, the flann index). In all methods to match, the method train() is run every time before matching.

The documentation for this class was generated from the following file:

- cudafeatures2d/include/opencv2/cudafeatures2d.hpp